// vim: foldmethod=marker

// XXX andy: stub for now, i guess
flock.xul.Popup = function (aPopup, aOpts) {
    flock.xul.Node.call(this, aPopup, aOpts);
}
dojo.inherits(flock.xul.Popup, flock.xul.Node);
dojo.lang.extend(flock.xul.Popup, {
    popupEvents: {
        "onPopupShowing": "popupshowing",
        "onPopupShown": "popupshown",
        "onPopupHiding": "popuphiding",
        "onPopupHidden": "popuphidden",
    },
    
    attach: function () {/*{{{*/
        if (this._isAttached) return;
        flock.xul.Node.prototype.attach.apply(this);
        for (evt in this.popupEvents) {
            if (!this[evt]) continue;
            this.addEventListener(this.popupEvents[evt], evt, false);
        }
        this._isAttached = true;
        XXX('isattachednow', this.isAttached);
    },/*}}}*/
    detach: function () {
        if (!this._isAttached) return;
        flock.xul.Node.prototype.detach.apply(this);
        for (var i = 0; i < this._eventListeners.length; ++i) {
            var c = this._eventListeners[i];
            this.removeEventListener(c.event, c.method, c.capture);
        }
        this._isAttached = false;
    }
    
});


// Popup used for aggregating multiple popups
// aOpts[popupSet] will fill from popupSet
flock.xul.SwitchingPopup = function (aPopup, aOpts) {
    this.popups = {};
    flock.xul.Popup.call(this, aPopup, aOpts);
    if (typeof this.popupSet == "string") {
        this.popupSet = $(this.popupSet);
    }
    if (this.popupSet) this.fillFromPopupSet(this.popupSet);
};
dojo.inherits(flock.xul.SwitchingPopup, flock.xul.Popup);
dojo.lang.extend(flock.xul.SwitchingPopup, {
    popups: null,
    popupSet: null,
    fillFromPopupSet: function (aPopupSet) {
        for (var i = 0; i < aPopupSet.childNodes.length; ++i) {
            var childMenu = aPopupSet.childNodes[i];
            if (childMenu.tagName != "menupopup") continue;
            this.popups[childMenu.id] = childMenu;
        }
    },
    switchTo: function (aSymb) {
        dojo.dom.removeChildren(this.mNode);
        dojo.dom.copyChildren(this.popups[aSymb], this.mNode, 1);  
    },
});



flock.xul.SwitchingContext = function (aNode, aPopup, aOpts) {


}
