function $(aID) { return document.getElementById(aID); }

var importOPML = {};

importOPML.accept = function() {
    var url = $("fileName").value;
    if (feedUtils.isValidURL(url)) {
        try {
            feedUtils.loadFeedFromLocalOPML(url);
            return true;
        } catch(e) {
            $("error").removeAttribute("hidden");
            return false;
        }
    } else {
        $("error").removeAttribute("hidden");
        return false;
    }
    return false;
}

importOPML.showFilePicker = function() {
    var nsIFilePicker = Components.interfaces.nsIFilePicker;
    var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
    fp.init(window, $("importOPML").getAttribute("filePickerText"), nsIFilePicker.modeOpen);
    fp.appendFilter($("importOPML").getAttribute("opmlFileTypeText"),"*.opml");
    var res = fp.show();
    if (res == nsIFilePicker.returnOK) {
        var file = fp.file;
        var url = feedUtils.getURLFromFile(file);
        $("fileName").value = url;
    }

}
